package com.sqx.modules.pay.service.impl;

import cn.hutool.core.util.StrUtil;
import cn.hutool.json.JSONUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.toolkit.ObjectUtils;
import com.github.wxpay.sdk.WXPay;
import com.github.wxpay.sdk.WXPayConstants;
import com.github.wxpay.sdk.WXPayUtil;
import com.sqx.common.constant.RedisKey;
import com.sqx.common.utils.RedisUtils;
import com.sqx.common.utils.Result;
import com.sqx.modules.app.bo.UpdateMoneyBO;
import com.sqx.modules.app.dao.UserDao;
import com.sqx.modules.app.dao.UserMoneyDetailsDao;
import com.sqx.modules.app.entity.UserEntity;
import com.sqx.modules.app.entity.UserMoney;
import com.sqx.modules.app.entity.UserMoneyDetails;
import com.sqx.modules.app.service.UserMoneyDetailsService;
import com.sqx.modules.app.service.UserMoneyService;
import com.sqx.modules.app.service.UserService;
import com.sqx.modules.common.entity.CommonInfo;
import com.sqx.modules.common.service.CommonInfoService;
import com.sqx.modules.datacentre.service.DataCentreService;
import com.sqx.modules.errand.entity.TbIndent;
import com.sqx.modules.errand.service.TbIndentService;
import com.sqx.modules.goods.dao.GoodsShopDao;
import com.sqx.modules.goods.entity.GoodsShop;
import com.sqx.modules.goods.service.GoodsShopService;
import com.sqx.modules.order.dao.AppOrderDao;
import com.sqx.modules.order.entity.TbOrder;
import com.sqx.modules.order.service.AppOrderService;
import com.sqx.modules.pay.config.WXConfig;
import com.sqx.modules.pay.controller.app.AliPayController;
import com.sqx.modules.pay.dao.PayDetailsDao;
import com.sqx.modules.pay.dto.PayOrderDTO;
import com.sqx.modules.pay.entity.PayDetails;
import com.sqx.modules.pay.service.WxService;
import com.sqx.modules.utils.AmountCalUtils;
import com.sqx.modules.utils.MD5Util;
import com.sqx.modules.utils.SenInfoCheckUtil;
import com.sqx.modules.utils.WXConfigUtil;
import lombok.extern.slf4j.Slf4j;
import org.redisson.api.RLock;
import org.redisson.api.RedissonClient;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * @author fang
 * @date 2020/2/26
 */
@Service
@Slf4j
public class WxServiceImpl implements WxService {
    private static final String SPBILL_CREATE_IP = "127.0.0.1";
    private static final String TRADE_TYPE_APP = "APP";
    private static final String TRADE_TYPE_JSAPI = "JSAPI";

    @Autowired
    private CommonInfoService commonInfoService;
    @Autowired
    private UserService userService;
    @Autowired
    private PayDetailsDao payDetailsDao;
    @Autowired
    private UserDao userDao;
    @Lazy
    @Autowired
    private AppOrderService appOrderService;
    @Autowired
    private AppOrderDao appOrderDao;
    @Autowired
    private UserMoneyService userMoneyService;
    @Autowired
    private UserMoneyDetailsDao userMoneyDetailsDao;
    @Autowired
    private GoodsShopDao goodsShopDao;
    @Lazy
    @Autowired
    private DataCentreService dataCentreService;
    @Lazy
    @Autowired
    private AliPayController aliPayController;
    @Lazy
    @Autowired
    private TbIndentService indentService;
    @Autowired
    private UserMoneyDetailsService userMoneyDetailsService;
    @Autowired
    private GoodsShopService goodsShopService;

    private SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

    @Resource
    private RedissonClient redissonClient;

    @Override
    public Result balanceOrder(Long userId, PayOrderDTO payOrderDTO) {
        TbOrder tbOrder = appOrderService.prepareOrder(userId, payOrderDTO);

        RLock lock = redissonClient.getLock(String.format(RedisKey.INSERT_ORDER_LOCK, tbOrder.getOrderId(), tbOrder.getShopId()));
        lock.lock();
        try{
            return balanceOrders(userId, tbOrder);
        } finally {
            lock.unlock();
        }
    }

    /**
     * 钱包支付订单
     */
    @Transactional
    public Result balanceOrders(Long userId, TbOrder tbOrder){
        // 扣除用户余额
        BigDecimal payMoney = tbOrder.getPayMoney();
        UserMoney userMoney = userMoneyService.selectUserMoneyByUserId(userId);
        if(payMoney.doubleValue() > userMoney.getMoney().doubleValue()){
            return Result.error("您的余额不足，请充值后再支付！");
        }
        userMoneyService.updateMoney(2, userId, payMoney.doubleValue());

        // 添加钱包消费记录
        UserMoneyDetails userMoneyDetails = new UserMoneyDetails();
        userMoneyDetails.setUserId(userId);
        userMoneyDetails.setTitle("余额支付");
        userMoneyDetails.setType(2);
        userMoneyDetails.setClassify(3);
        userMoneyDetails.setState(2);
        userMoneyDetails.setMoney(payMoney);
        userMoneyDetails.setContent("使用余额支付："+ String.format("%.2f", payMoney) +"元");
        userMoneyDetails.setCreateTime(sdf.format(new Date()));
        userMoneyDetailsDao.insert(userMoneyDetails);

        // 设置订单支付方式 2为余额支付
        tbOrder.setPayType(2);

        // 订单支付成功
        appOrderService.updateOrderAfterPaySuccess(tbOrder);

        return Result.success();
    }

    @Override
    public Result balanceBuyVip(Long userId) {
        RLock lock = redissonClient.getLock(String.format(RedisKey.USER_BUY_VIP_LOCK, userId));
        lock.lock();
        try {
            return balanceBuyVips(userId);
        } finally {
            lock.unlock();
        }
    }

    @Override
    public Result wxPayJsApiBuyVip(Long userId, Integer type) throws Exception {
        String generalOrder = getGeneralOrder();
        CommonInfo one = commonInfoService.findOne(313);
        if(type==4||type==5){
            return aliPayController.payVip(Double.valueOf(one.getValue()), type, userId, generalOrder, 4);
        }
        return pay(Double.valueOf(one.getValue()), type, userId, generalOrder, 4);
    }

    @Transactional
    public Result balanceBuyVips(Long userId){
        CommonInfo one = commonInfoService.findOne(313);
        UserMoney userMoney = userMoneyService.selectUserMoneyByUserId(userId);
        if(userMoney.getMoney().doubleValue()<Double.valueOf(one.getValue())){
            return Result.error("余额不足！");
        }
        userMoneyService.updateMoney(2, userId, Double.valueOf(one.getValue()));
        dataCentreService.presenterVip(userId);
        UserMoneyDetails userMoneyDetails = new UserMoneyDetails();
        userMoneyDetails.setUserId(userId);
        userMoneyDetails.setTitle("用户开通会员");
        userMoneyDetails.setState(2);
        userMoneyDetails.setType(2);
        userMoneyDetails.setClassify(3);
        userMoneyDetails.setMoney(BigDecimal.valueOf(Double.valueOf(one.getValue())));
        userMoneyDetails.setContent("用户开通会员，花费"+Double.valueOf(one.getValue())+"元");
        userMoneyDetails.setCreateTime(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
        userMoneyDetailsDao.insert(userMoneyDetails);
        return Result.success();
    }

    @Override
    public Result shopCashDeposit(Long shopId, Double money, String openId,Integer type) throws Exception {
        GoodsShop goodsShop = goodsShopDao.selectById(shopId);
        if(goodsShop.getStatus()!=1){
            return Result.error("管理端审核成功后才能交保证金");
        }
        String generalOrder = getGeneralOrder();
        return shopPay(money,generalOrder, openId, shopId, type);
    }

    @Override
    public Result payMoney(Long userId, BigDecimal money, Integer type) throws Exception {
        String generalOrder = getGeneralOrder();
        if(type==4||type==5){
            return aliPayController.aliPayMoney(money.doubleValue(), type, userId, generalOrder, 2);
        }
        return pay(money.doubleValue(), type, userId, generalOrder, 2);
    }

    /**
     * 微信/支付宝支付订单
     * @param userId 用户id
     * @param payOrderDTO 支付订单
     */
    @Override
    public Result payOrder(Long userId, PayOrderDTO payOrderDTO) throws Exception {
        TbOrder tbOrder = appOrderService.prepareOrder(userId, payOrderDTO);

        // 设置支付方式 1表示微信支付、4或5表示支付宝支付
        Integer type = payOrderDTO.getType();

        RLock lock = redissonClient.getLock(String.format(RedisKey.INSERT_ORDER_LOCK, tbOrder.getUserId(), tbOrder.getShopId()));
        lock.lock();
        try {

            Integer status = tbOrder.getStatus();
            if (status==0) {
                //            获取超时时间
                Long timeOut = tbOrder.getTimeOut();
                if (ObjectUtils.isNotEmpty(timeOut)) {
                    long time = new Date().getTime();

                    if (timeOut<time) {
                        return Result.error("订单已过期");
                    }
                }
            }else {
                // 设置订单号
                if (StrUtil.isBlank(tbOrder.getOrderNumber())) {
                    tbOrder.setOrderNumber(getGeneralOrder());
                }

                // 支付时，订单状态改为 0
                tbOrder.setStatus(0);


//            超时时间
                Date date = new Date();
                long time1 = date.getTime()+15*60*1000;
                tbOrder.setTimeOut(time1);
            }

            tbOrder.setPayType(1);
            if(type == 4 || type == 5){
                tbOrder.setPayType(3);
            }



            // 保存订单信息
            appOrderDao.updateById(tbOrder);

            if (tbOrder.getPayType() == 1) {
                // 微信支付
                return pay(tbOrder.getPayMoney().doubleValue(), type, tbOrder.getUserId(), tbOrder.getOrderNumber(), 1);
            } else {
                // 支付宝支付
                return aliPayController.payAppOrders(tbOrder.getPayMoney().doubleValue(), type, tbOrder.getUserId(), tbOrder.getOrderNumber(), 1);
            }
        } finally {
            lock.unlock();
        }
    }

    /**
     * 微信支付订单生成
     *
     * @param moneys     支付金额 带小数点
     * @param type       类型 1app  2 二维码支付  3小程序 公众号支付
     * @param userId     用户id
     * @param outTradeNo 单号
     * @param classify   支付类型  1支付订单  2充值
     * @return
     * @throws Exception
     */
    private Result pay(Double moneys, Integer type, Long userId, String outTradeNo, Integer classify) throws Exception {
        //h5服务域名配置
        CommonInfo oneu = commonInfoService.findOne(19);
        String url;
        if (type == 3) {
            url = oneu.getValue() + "/sqx_fast/app/wxPay/notifyJsApi";//小程序支付
        } else if (type == 2) {
            url = oneu.getValue() + "/sqx_fast/app/wxPay/notifyMp";//公众号支付
        } else {
            url = oneu.getValue() + "/sqx_fast/app/wxPay/notify";//app支付
        }
        String currentTimeMillis=(System.currentTimeMillis() / 1000)+"";
        Double mul = AmountCalUtils.mul(moneys, 100);
        String money = String.valueOf(mul.intValue());
        String generateNonceStr = WXPayUtil.generateNonceStr();
        WXConfig config = new WXConfig();
        //微信小程序APPID        微信公众号APPID
        if(type==1){
            config.setAppId(commonInfoService.findOne(74).getValue());
        }else if(type==2){
            config.setAppId(commonInfoService.findOne(5).getValue());
        }else if(type==3){
            config.setAppId(commonInfoService.findOne(45).getValue());
        }
        //微信商户号mchId
        config.setMchId(commonInfoService.findOne(76).getValue());
        //微信商户key
        config.setKey(commonInfoService.findOne(75).getValue());
        WXPay wxpay = new WXPay(config);
        Map<String, String> data = new HashMap<>();
        //微信对应appid 小程序  公众号  app id
        data.put("appid", config.getAppID());
        //商户号
        data.put("mch_id", config.getMchID());
        //订单号
        data.put("nonce_str", generateNonceStr);
        String body = "";
        if(classify==1){
            //订单类型
            body = "下单支付";
        }else if(classify==2){
            body = "充值余额";
        }else if(classify==4){
            body = "购买会员";
        }
        //订单内容
        data.put("body", body);
        //生成商户订单号，不可重复
        data.put("out_trade_no", outTradeNo);
        data.put("total_fee", money);
        //自己的服务器IP地址
        data.put("spbill_create_ip", SPBILL_CREATE_IP);
        //异步通知地址（请注意必须是外网）
        data.put("notify_url", url);
        //交易类型
        data.put("trade_type", type == 1 ? TRADE_TYPE_APP : TRADE_TYPE_JSAPI );
        //附加数据，在查询API和支付通知中原样返回，该字段主要用于商户携带订单的自定义数据
        data.put("attach", "");
        data.put("sign", WXPayUtil.generateSignature(data, config.getKey(),
                WXPayConstants.SignType.MD5));
        if(type==3 || type == 2){
            UserEntity userEntity = userService.queryByUserId(userId);
            if(type==2){
                data.put("openid", userEntity.getWxOpenId());
            }else{
                data.put("openid", userEntity.getOpenId());
            }
        }
        //使用官方API请求预付订单
        Map<String, String> response = wxpay.unifiedOrder(data);
        if ("SUCCESS".equals(response.get("return_code"))) {
            PayDetails payDetails = payDetailsDao.selectByOrderId(outTradeNo);
            if(payDetails==null){
                payDetails = new PayDetails();
                payDetails.setState(0);
                payDetails.setCreateTime(sdf.format(new Date()));
                payDetails.setOrderId(outTradeNo);
                payDetails.setUserId(userId);
                payDetails.setMoney(AmountCalUtils.divide(Double.parseDouble(money), 100));
                payDetails.setClassify(classify);
                payDetails.setType(type);
                payDetailsDao.insert(payDetails);
            }
            if (type == 1) {
                Map<String, String> param = new HashMap<>();
                param.put("appid", config.getAppID());
                param.put("partnerid", response.get("mch_id"));
                param.put("prepayid", response.get("prepay_id"));
                param.put("package", "Sign=WXPay");
                param.put("noncestr", generateNonceStr);
                param.put("timestamp", currentTimeMillis);
                param.put("sign", WXPayUtil.generateSignature(param, config.getKey(),
                        WXPayConstants.SignType.MD5));
                param.put("outtradeno", outTradeNo);
                return Result.success().put("data", param);
            } else {
                Map<String, String> param = new HashMap<>();
                param.put("appid", config.getAppID());
                param.put("partnerid", response.get("mch_id"));
                param.put("prepayid", response.get("prepay_id"));
                param.put("noncestr", generateNonceStr);
                param.put("timestamp", currentTimeMillis);
                    /*param.put("sign", WXPayUtil.generateSignature(param, config.getKey(),
                            WXPayConstants.SignType.MD5));*/
                String stringSignTemp = "appId=" + config.getAppID() + "&nonceStr=" + generateNonceStr + "&package=prepay_id=" + response.get("prepay_id") + "&signType=MD5&timeStamp=" + currentTimeMillis + "" + "&key=" + config.getKey();
                String sign = MD5Util.md5Encrypt32Upper(stringSignTemp).toUpperCase();
                param.put("sign", sign);
                param.put("outtradeno", outTradeNo);
                param.put("package", "prepay_id=" + response.get("prepay_id"));//给前端返回的值
                param.put("mweb_url", response.get("mweb_url"));
                param.put("trade_type", response.get("trade_type"));
                param.put("return_msg", response.get("return_msg"));
                param.put("result_code", response.get("result_code"));
                param.put("signType", "MD5");
                return Result.success().put("data", param);
            }
        } else {
            log.error("获取微信支付参数异常，异常信息：{}", JSONUtil.toJsonStr(response));
        }
        return Result.error("获取订单失败");
    }

    /**
     * 商家缴纳保证金
     * @param moneys
     * @param outTradeNo
     * @param openId
     * @param shopId
     * @param type
     * @return
     * @throws Exception
     */
    private Result shopPay(Double moneys, String outTradeNo, String openId, Long shopId, Integer type) throws Exception {
        //h5服务域名配置
        CommonInfo oneu = commonInfoService.findOne(19);
        String url;
        if (type == 3) {
            url = oneu.getValue() + "/sqx_fast/app/wxPay/notifyJsApiShop";//小程序支付
        } else if (type == 2) {
            url = oneu.getValue() + "/sqx_fast/app/wxPay/notifyMpShop";//公众号支付
        } else {
            url = oneu.getValue() + "/sqx_fast/app/wxPay/notifyShop";//app支付
        }
        String currentTimeMillis=(System.currentTimeMillis() / 1000)+"";
        //后台服务名称
        CommonInfo one = commonInfoService.findOne(12);
        log.info("回调地址：" + url);
        Double mul = AmountCalUtils.mul(moneys, 100);
        String money = String.valueOf(mul.intValue());
        String generateNonceStr = WXPayUtil.generateNonceStr();
        WXConfig config = new WXConfig();
        /*//微信小程序APPID
        config.setAppId(commonInfoService.findOne(305).getValue());*/
        //微信小程序APPID        微信公众号APPID
        if(type==1){
            config.setAppId(commonInfoService.findOne(337).getValue());
        }else if(type==2){
            config.setAppId(commonInfoService.findOne(5).getValue());
        }else if(type==3){
            config.setAppId(commonInfoService.findOne(305).getValue());
        }
        //微信商户key
        config.setKey(commonInfoService.findOne(75).getValue());
        //微信商户号mchId
        config.setMchId(commonInfoService.findOne(76).getValue());
        WXPay wxpay = new WXPay(config);
        Map<String, String> data = new HashMap<>();
        //微信对应appid 小程序  公众号  app id
        data.put("appid", config.getAppID());
        //商户号
        data.put("mch_id", config.getMchID());
        //订单号
        data.put("nonce_str", generateNonceStr);
        String body = one.getValue();
        //订单内容
        data.put("body", body);
        //生成商户订单号，不可重复
        data.put("out_trade_no", outTradeNo);
        data.put("total_fee", money);
        //自己的服务器IP地址
        data.put("spbill_create_ip", SPBILL_CREATE_IP);
        //异步通知地址（请注意必须是外网）
        data.put("notify_url", url);
        //交易类型
        data.put("trade_type", type == 1 ? TRADE_TYPE_APP : TRADE_TYPE_JSAPI );
        //附加数据，在查询API和支付通知中原样返回，该字段主要用于商户携带订单的自定义数据
        data.put("attach", "");
        data.put("sign", WXPayUtil.generateSignature(data, config.getKey(),
                WXPayConstants.SignType.MD5));
        if(type==3 || type == 2){
            data.put("openid", openId);
        }
        //使用官方API请求预付订单
        Map<String, String> response = wxpay.unifiedOrder(data);
        for (String key : response.keySet()) {
            log.info("微信支付订单微信返回参数：keys:" + key + "    value:" + response.get(key).toString());
        }
        if ("SUCCESS".equals(response.get("return_code"))) {//主要返回以下5个参数
            PayDetails payDetails = payDetailsDao.selectByOrderId(outTradeNo);
            if(payDetails==null){
                payDetails = new PayDetails();
                payDetails.setState(0);
                payDetails.setCreateTime(sdf.format(new Date()));
                payDetails.setOrderId(outTradeNo);
                payDetails.setShopId(shopId);
                payDetails.setMoney(AmountCalUtils.divide(Double.parseDouble(money), 100));
                payDetails.setClassify(3);
                payDetails.setType(type);
                payDetails.setRemark(String.valueOf(shopId));
                payDetailsDao.insert(payDetails);
            }

            if (type == 1) {
                Map<String, String> param = new HashMap<>();
                param.put("appid", config.getAppID());
                param.put("partnerid", response.get("mch_id"));
                param.put("prepayid", response.get("prepay_id"));
                param.put("package", "Sign=WXPay");
                param.put("noncestr", generateNonceStr);
                param.put("timestamp", currentTimeMillis);
                param.put("sign", WXPayUtil.generateSignature(param, config.getKey(),
                        WXPayConstants.SignType.MD5));
                param.put("outtradeno", outTradeNo);
                return Result.success().put("data", param);
            } else {
                Map<String, String> param = new HashMap<>();
                param.put("appid", config.getAppID());
                param.put("partnerid", response.get("mch_id"));
                param.put("prepayid", response.get("prepay_id"));
                param.put("noncestr", generateNonceStr);
                param.put("timestamp", currentTimeMillis);
                    /*param.put("sign", WXPayUtil.generateSignature(param, config.getKey(),
                            WXPayConstants.SignType.MD5));*/
                String stringSignTemp = "appId=" + config.getAppID() + "&nonceStr=" + generateNonceStr + "&package=prepay_id=" + response.get("prepay_id") + "&signType=MD5&timeStamp=" + currentTimeMillis + "" + "&key=" + config.getKey();
                String sign = MD5Util.md5Encrypt32Upper(stringSignTemp).toUpperCase();
                param.put("sign", sign);
                param.put("outtradeno", outTradeNo);
                param.put("package", "prepay_id=" + response.get("prepay_id"));//给前端返回的值
                param.put("mweb_url", response.get("mweb_url"));
                param.put("trade_type", response.get("trade_type"));
                param.put("return_msg", response.get("return_msg"));
                param.put("result_code", response.get("result_code"));
                param.put("signType", "MD5");
                return Result.success().put("data", param);
            }
        }
        return Result.error("获取订单失败");
    }

    @Override
    public String payBack(String resXml, Integer type) {
        WXConfig config = null;
        try {
            config = new WXConfig();
        } catch (Exception e) {
            e.printStackTrace();
        }
        if(type==1){
            config.setAppId(commonInfoService.findOne(74).getValue());
        }else if(type==2){
            config.setAppId(commonInfoService.findOne(5).getValue());
        }else{
            config.setAppId(commonInfoService.findOne(45).getValue());
        }
        config.setKey(commonInfoService.findOne(75).getValue());
        config.setMchId(commonInfoService.findOne(76).getValue());
        WXPay wxpay = new WXPay(config);
        String xmlBack = "";
        Map<String, String> notifyMap = null;
        try {
            notifyMap = WXPayUtil.xmlToMap(resXml);         // 调用官方SDK转换成map类型数据
            if (wxpay.isPayResultNotifySignatureValid(notifyMap)) {//验证签名是否有效，有效则进一步处理
                log.error("验证成功！！！");
                String return_code = notifyMap.get("return_code");//状态
                String out_trade_no = notifyMap.get("out_trade_no");//商户订单号
                if (return_code.equals("SUCCESS")) {
                    log.error("验证成功222！！！");
                    if (out_trade_no != null) {
                        // 注意特殊情况：订单已经退款，但收到了支付结果成功的通知，不应把商户的订单状态从退款改成支付成功
                        // 注意特殊情况：微信服务端同样的通知可能会多次发送给商户系统，所以数据持久化之前需要检查是否已经处理过了，处理了直接返回成功标志
                        //业务数据持久化
                        log.error("订单号！！！" + out_trade_no);
                        PayDetails payDetails = payDetailsDao.selectByOrderId(out_trade_no);
                        //设置查询条件
                        if (payDetails.getState() == 0) {
                            payDetailsDao.updateState(payDetails.getId(), 1, sdf.format(new Date()), "");
                            //调用处理接口
                            //业务操作
                            notfiy(payDetails);

                        }
                        System.err.println("微信手机支付回调成功订单号:" + out_trade_no + "");
                        xmlBack = "<xml>" + "<return_code><![CDATA[SUCCESS]]></return_code>" + "<return_msg><![CDATA[OK]]></return_msg>" + "</xml> ";
                    } else {
                        System.err.println("微信手机支付回调成功订单号:" + out_trade_no + "");
                        xmlBack = "<xml>" + "<return_code><![CDATA[FAIL]]></return_code>" + "<return_msg><![CDATA[报文为空]]></return_msg>" + "</xml> ";
                    }
                } else {
                }
                return xmlBack;
            } else {
                // 签名错误，如果数据里没有sign字段，也认为是签名错误
                System.err.println("手机支付回调通知签名错误");
                xmlBack = "<xml>" + "<return_code><![CDATA[FAIL]]></return_code>" + "<return_msg><![CDATA[报文为空]]></return_msg>" + "</xml> ";
                return xmlBack;
            }
        } catch (Exception e) {
            System.err.println("手机支付回调通知失败" + e);
            xmlBack = "<xml>" + "<return_code><![CDATA[FAIL]]></return_code>" + "<return_msg><![CDATA[报文为空]]></return_msg>" + "</xml> ";
            log.error("支付回调异常！",e.getMessage(), e);
        }
        return xmlBack;
    }

    @Override
    public String payBackShop(String resXml, Integer type) {
        WXConfig config = null;
        try {
            config = new WXConfig();
        } catch (Exception e) {
            e.printStackTrace();
        }
        log.error("进入回调了！！！");
        if(type==1){
            config.setAppId(commonInfoService.findOne(337).getValue());
        }else if(type==2){
            config.setAppId(commonInfoService.findOne(5).getValue());
        }else if(type==3){
            config.setAppId(commonInfoService.findOne(305).getValue());
        }
        config.setKey(commonInfoService.findOne(75).getValue());
        config.setMchId(commonInfoService.findOne(76).getValue());
        WXPay wxpay = new WXPay(config);
        String xmlBack = "";
        Map<String, String> notifyMap = null;
        try {
            notifyMap = WXPayUtil.xmlToMap(resXml);         // 调用官方SDK转换成map类型数据
            if (wxpay.isPayResultNotifySignatureValid(notifyMap)) {//验证签名是否有效，有效则进一步处理
                log.error("验证成功！！！");
                String return_code = notifyMap.get("return_code");//状态
                String out_trade_no = notifyMap.get("out_trade_no");//商户订单号
                if (return_code.equals("SUCCESS")) {
                    log.error("验证成功222！！！");
                    if (out_trade_no != null) {
                        // 注意特殊情况：订单已经退款，但收到了支付结果成功的通知，不应把商户的订单状态从退款改成支付成功
                        // 注意特殊情况：微信服务端同样的通知可能会多次发送给商户系统，所以数据持久化之前需要检查是否已经处理过了，处理了直接返回成功标志
                        //业务数据持久化
                        log.error("订单号！！！" + out_trade_no);
                        PayDetails payDetails = payDetailsDao.selectByOrderId(out_trade_no);
                        //设置查询条件
                        if (payDetails.getState() == 0) {
                            payDetailsDao.updateState(payDetails.getId(), 1, sdf.format(new Date()), "");
                            //调用处理接口
                            //业务操作
                            notfiy(payDetails);

                        }
                        System.err.println("微信手机支付回调成功订单号:" + out_trade_no + "");
                        xmlBack = "<xml>" + "<return_code><![CDATA[SUCCESS]]></return_code>" + "<return_msg><![CDATA[OK]]></return_msg>" + "</xml> ";
                    } else {
                        System.err.println("微信手机支付回调成功订单号:" + out_trade_no + "");
                        xmlBack = "<xml>" + "<return_code><![CDATA[FAIL]]></return_code>" + "<return_msg><![CDATA[报文为空]]></return_msg>" + "</xml> ";
                    }
                } else {
                }
                return xmlBack;
            } else {
                // 签名错误，如果数据里没有sign字段，也认为是签名错误
                System.err.println("手机支付回调通知签名错误");
                xmlBack = "<xml>" + "<return_code><![CDATA[FAIL]]></return_code>" + "<return_msg><![CDATA[报文为空]]></return_msg>" + "</xml> ";
                return xmlBack;
            }
        } catch (Exception e) {
            System.err.println("手机支付回调通知失败" + e);
            xmlBack = "<xml>" + "<return_code><![CDATA[FAIL]]></return_code>" + "<return_msg><![CDATA[报文为空]]></return_msg>" + "</xml> ";
            log.error("支付回调异常！",e.getMessage(), e);
        }
        return xmlBack;
    }


    public String getGeneralOrder() {
        Date date = new Date();
        String newString = String.format("%0" + 4 + "d", (int) ((Math.random() * 9 + 1) * 1000));
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
        String format = sdf.format(date);
        return format + newString;
    }

    @Override
    public void notifyRider(PayDetails payDetails){
        if(payDetails.getClassify()==1){
            //充值金额
            payDetails.setClassify(1);//分类：1微信  2支付宝
            String date = new SimpleDateFormat("yyyy-MM-dd :HH:mm:ss").format(new Date());
            payDetails.setType(1);
            userDao.topUpMoney(payDetails.getClassify(), payDetails.getTradeNo(),payDetails.getMoney(),payDetails.getUserId(),payDetails.getState(),date,date,payDetails.getType());
        }else if(payDetails.getClassify()==2){
            //订单支付
            TbIndent indentByIndentNumber = indentService.findIndentByIndentNumber(payDetails.getOrderId());
            indentByIndentNumber.setIndentState("2");
            indentService.updateById(indentByIndentNumber);
        }else if(payDetails.getClassify()==3){
            //将保证金添加到骑手保证金里
            Double cashDeposit = payDetails.getMoney();
            Long userId = payDetails.getUserId();
            userDao.updateCashDeposit(userId, cashDeposit);
            //交保证金的记录
            UserMoneyDetails userMoneyDetails=new UserMoneyDetails();
            userMoneyDetails.setUserId(userId);
            userMoneyDetails.setTitle("骑手缴纳保证金");
            userMoneyDetails.setContent("骑手缴纳保证金："+cashDeposit+"元");
            userMoneyDetails.setType(1);
            userMoneyDetails.setClassify(1);
            userMoneyDetails.setState(2);
            userMoneyDetails.setMoney(BigDecimal.valueOf(cashDeposit));
            userMoneyDetails.setCreateTime(new SimpleDateFormat("yyyy-MM-dd :HH:mm:ss").format(new Date()));
            userMoneyDetailsService.save(userMoneyDetails);


            String remark = payDetails.getRemark();
            JSONObject user = JSONObject.parseObject(remark);

            String format = new SimpleDateFormat("yyyy-MM-dd :HH:mm:ss").format(new Date());
            userDao.certification(Long.parseLong(user.getString("userId")),user.getString("phone"),
                    user.getString("userName"), user.getString("identityCardNumber"), user.getString("identityCardFront"),
                    user.getString("identityCardVerso"),user.getString("selfIdentityCard"), format,payDetails.getOrderId(),
                    user.getBigDecimal("cashDeposit"));

        }else if(payDetails.getClassify()==4){
            Long userId = payDetails.getUserId();
            Double money = payDetails.getMoney();
            UserEntity userEntity = userDao.selectById(userId);
            BigDecimal cashDeposit = userEntity.getCashDeposit().add(BigDecimal.valueOf(money));
            UserEntity userEntity1 = new UserEntity();
            userEntity1.setUserId(userId);
            userEntity1.setCashDeposit(cashDeposit);
            userDao.updateById(userEntity1);

            //交保证金的记录
            UserMoneyDetails userMoneyDetails=new UserMoneyDetails();
            userMoneyDetails.setUserId(userId);
            userMoneyDetails.setTitle("骑手缴纳保证金");
            userMoneyDetails.setContent("骑手缴纳保证金："+payDetails.getMoney()+"元");
            userMoneyDetails.setType(1);
            userMoneyDetails.setClassify(1);
            userMoneyDetails.setState(2);
            userMoneyDetails.setMoney(BigDecimal.valueOf(payDetails.getMoney()));
            userMoneyDetails.setCreateTime(new SimpleDateFormat("yyyy-MM-dd :HH:mm:ss").format(new Date()));
            userMoneyDetailsService.save(userMoneyDetails);
        }
    }

    @Resource
    private RedisUtils redisUtils;

    @Override
    public String getAccessToken(String type) {
        String token = null;
        if (StrUtil.equals(type, "1")) {
            token = SenInfoCheckUtil.getMpToken();
        } else if (StrUtil.equals(type, "2")) {
            token = SenInfoCheckUtil.getShopMpToken();
        } else if (StrUtil.equals(type, "3")) {
            token = SenInfoCheckUtil.getRiderMpToken();
        }
        return token;
    }

    @Transactional
    @Override
    public void notfiy(PayDetails payDetails){
        if(payDetails.getClassify()==2){
            UpdateMoneyBO updateMoneyBO = UpdateMoneyBO.builder()
                    .type(1)
                    .classify(3)
                    .userId(payDetails.getUserId())
                    .amount(new BigDecimal(payDetails.getMoney()))
                    .title("充值入账")
                    .remark(payDetails.getOrderId())
                    .build();
            userMoneyService.updateUserMoney(updateMoneyBO);
        }else if(payDetails.getClassify()==1){
            // 根据订单编号查询订单
            TbOrder tbOrder = appOrderService.selectOrderByNum(payDetails.getOrderId());

            // 订单支付成功，修改订单状态
            appOrderService.updateOrderAfterPaySuccess(tbOrder);
        }else if(payDetails.getClassify()==3){
            //商户交保证金
            goodsShopService.updateCashDeposit(payDetails.getMoney(), payDetails.getShopId(), payDetails.getOrderId());
        }else if(payDetails.getClassify()==4){
            PayDetails payDetails1 = new PayDetails();
            payDetails1.setId(payDetails.getId());
            payDetails1.setState(1);
            payDetailsDao.updateById(payDetails1);
            dataCentreService.presenterVip(payDetails.getUserId());
            UserMoneyDetails userMoneyDetails = new UserMoneyDetails();
            userMoneyDetails.setUserId(payDetails.getUserId());
            userMoneyDetails.setTitle("用户开通会员");
            userMoneyDetails.setState(2);
            userMoneyDetails.setType(1);
            userMoneyDetails.setClassify(3);
            userMoneyDetails.setMoney(BigDecimal.valueOf(payDetails.getMoney()));
            userMoneyDetails.setContent("用户开通会员，花费"+payDetails.getMoney()+"元");
            userMoneyDetails.setCreateTime(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
            userMoneyDetailsDao.insert(userMoneyDetails);
        }else if(payDetails.getClassify()==5){
            //订单支付
            TbIndent indentByIndentNumber = indentService.findIndentByPayOrdersNo(payDetails.getOrderId());
            indentByIndentNumber.setIndentState("2");
            indentService.updateById(indentByIndentNumber);
            indentService.sendNewIndentMsg(indentByIndentNumber);
        }
    }


    /*@Override
    public boolean refund(Orders orders) {
        WXConfigUtil config = null;
        try {
            config = new WXConfigUtil();
        } catch (Exception e) {
            e.printStackTrace();
        }
        int commInfoId = 0;
        Integer payWay = null;
        //orders.getPayWay(); //支付方式（1app微信 2微信公众号 3微信小程序 4app支付宝 5H5支付宝 6零钱）
        switch (payWay) {
            case 1:
                commInfoId = 5;
                break; //appId
            case 2:
                commInfoId = 74;
                break; //公众号id
            case 3:
                commInfoId = 45;
                break; //小程序id
        }
        config.setAppId(commonInfoService.findOne(commInfoId).getValue());
        config.setKey(commonInfoService.findOne(75).getValue());
        config.setMchId(commonInfoService.findOne(76).getValue());
        WXPay wxpay = new WXPay(config);
        Map<String, String> data = new HashMap<>();
        data.put("appid", config.getAppID());
        data.put("mch_id", config.getMchID());
        data.put("nonce_str", WXPayUtil.generateNonceStr());
        try {
            data.put("sign", WXPayUtil.generateSignature(data, config.getKey(), WXPayConstants.SignType.MD5));
        } catch (Exception e) {
            e.printStackTrace();
            return false;
        }
        data.put("out_trade_no", orders.getOrdersNo()); //订单号,支付单号一致
        data.put("out_refund_no", orders.getOrdersNo()); //退款单号，同一笔用不同的退款单号
        double total_fee = 0.00;
        data.put("total_fee", new Double(orders.getPayMoney().doubleValue() * 100).intValue() + ""); //1块等于微信支付传入100);
        data.put("refund_fee", new Double(orders.getPayMoney().doubleValue() * 100).intValue() + ""); //1块等于微信支付传入100);
        //使用官方API退款
        try {
            Map<String, String> response = wxpay.refund(data);
            if ("SUCCESS".equals(response.get("return_code"))) {//主要返回以下5个参数
                System.err.println("退款成功");
                return true;
            } else {
                return false;
            }
        } catch (Exception e) {
            log.info("返回");
            e.printStackTrace();
            return false;
        }
    }*/

    @Override
    public boolean wxRefund(PayDetails payDetails){
        WXConfigUtil config = null;
        try {
            config = new WXConfigUtil();
        } catch (Exception e) {
            e.printStackTrace();
        }
        int commInfoId = 0;
        Integer payWay = payDetails.getType(); //支付方式（1app微信 2微信公众号 3微信小程序 4app支付宝 5H5支付宝 6零钱）
        switch (payWay){
            case 1 : commInfoId = 74; break; //appId
            case 2 : commInfoId = 5; break; //公众号id
            case 3 : commInfoId = 45; break; //小程序id
        }
        config.setAppId(commonInfoService.findOne(commInfoId).getValue());
        config.setKey(commonInfoService.findOne(75).getValue());
        config.setMchId(commonInfoService.findOne(76).getValue());
        WXPay wxpay = new WXPay(config);
        Map<String, String> data = new HashMap<>();
        data.put("appid", config.getAppID());
        data.put("mch_id", config.getMchID());
        data.put("nonce_str", WXPayUtil.generateNonceStr());
        try{
            data.put("sign", WXPayUtil.generateSignature(data, config.getKey(), WXPayConstants.SignType.MD5));
        }catch (Exception e){
            e.printStackTrace();
            return false;
        }
        data.put("out_trade_no", payDetails.getOrderId()); //订单号,支付单号一致
        data.put("out_refund_no", payDetails.getOrderId()); //退款单号，同一笔用不同的退款单号
        double total_fee = 0.00;
        data.put("total_fee",String.valueOf((new BigDecimal(payDetails.getMoney()).multiply(BigDecimal.valueOf(100))).intValue())); //1块等于微信支付传入100);
        data.put("refund_fee",String.valueOf((new BigDecimal(payDetails.getMoney()).multiply(BigDecimal.valueOf(100))).intValue())); //1块等于微信支付传入100);
        //使用官方API退款
        try{
            Map<String, String> response = wxpay.refund(data);
            if ("SUCCESS".equals(response.get("return_code"))) {//主要返回以下5个参数
                System.err.println("退款成功");
                return true;
            }else {
                return false;
            }
        }catch (Exception e){
            log.error("返回");
            e.printStackTrace();
            log.error("微信退款失败！，订单号"+payDetails.getOrderId()+"，失败原因："+e.getMessage(),e);
            return false;
        }
    }


}